﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WinFormsCustomControls {
	class MyControl : Control {

		public MyControl() {
			SetStyle(ControlStyles.ResizeRedraw, true);

			SetStyle(ControlStyles.AllPaintingInWmPaint
				| ControlStyles.OptimizedDoubleBuffer | ControlStyles.UserPaint, true);
		}

		protected override void OnPaint(PaintEventArgs e) {
			Graphics g = e.Graphics;

			g.Clear(Color.Pink);

			g.DrawLine(Pens.Black, 0, 0, ClientSize.Width, ClientSize.Height);
			Pen p = new Pen(Color.Black, 10);
			g.DrawLine(p, ClientSize.Width, 0, 0, ClientSize.Height);

			g.FillRectangle(Brushes.Red, 10, 10, 10, 10);
		}
	}
}
